
%define XID _ULONG
%define Window XID
%define VisualID _ULONG
%define GContext XID 
%define Colormap XID

extern XOpenDisplay
extern XCreateSimpleWindow
extern XStoreName
extern XCreateGC
extern XSetForeground
extern XSelectInput
extern XMapWindow 
extern XNextEvent
extern XDrawString

%ifidn __OUTPUT_FORMAT__,elf64
		
	%define __INT_SIZE__ 4
	%define __UI_SIZE__ 4
	%define __POINTER_SIZE__ 8
	%define __UL_SIZE__ 8
	%define __L_SIZE__ 8
	%define __CHAR_SIZE__ 1
	%define __SHORT_SIZE__ 2
%else
	;;;;;;;:TODO;;;;;;;;;
	;;%define __INT_SIZE__ 4
	;;%define __UI_SIZE__ 4
	;;%define __POINTER_SIZE__ 8
	;;%define __UL_SIZE__ 8
	;;%define __L_SIZE__ 8
	;;%define __CHAR_SIZE__ 1
	;;%define __SHORT_SIZE__ 2
	;;;;;;;:TODO;;;;;;;;;
%endif


%macro _CHAR 1-*
	%rep %0
		%1 resb __CHAR_SIZE__
		%rotate 1	
	%endrep	
%endmacro
%macro _SHORT 1-*
	%rep %0
		%ifctx __STRUC__
			alignb __SHORT_SIZE__
		%endif			
		%1 resb __SHORT_SIZE__
		%rotate 1	
	%endrep	
%endmacro

%macro _INT 1-*
	%rep %0
		%ifctx __STRUC__
			alignb __INT_SIZE__
		%endif			
		%1 resb __INT_SIZE__
		%rotate 1	
	%endrep	
%endmacro
%define _UINT _INT

%macro _POINTER 1-*
	%rep %0
		%ifctx __STRUC__
			alignb __POINTER_SIZE__
		%endif			
		%1 resb __POINTER_SIZE__
		%rotate 1
	%endrep
%endmacro
%define _ULONG _POINTER
%define _LONG  _POINTER
%define _FUNCPTR _POINTER
%define _BOOL  _CHAR

%imacro stdecl 2
	%2 resb %1_size
	%define %2(x) %2 + %1. %+ x
%endmacro

%imacro _struc 1
	struc %1
	%push __STRUC__
%endmacro

%imacro _endstruc 0
	%ifnctx __STRUC__
		%fatal _struc expected before _endstruc
	%else
		%pop
		endstruc
	%endif
	
%endmacro

_struc   _XDisplay 
	_POINTER 	.ext_data		;;;XExtData *ext_data;
	_POINTER 	.private1		;;;struct _XPrivate *private1;
	_INT 		.fd			;;;int fd;
	_INT 		.private2		;;;int private2;
	_INT 		.proto_major_version	;;;int proto_major_version;/* major version of server's X protocol */
	_INT 		.proto_minor_version	;;;int proto_minor_version;/* minor version of servers X protocol */
			
	_POINTER 	.vendor			;;;char *vendor;		/* vendor of the server hardware */
        _ULONG 		.private3		;;;XID private3;
	_ULONG 		.private4		;;;XID private4;
	_ULONG 		.private5		;;;XID private5;
	_INT 		.private6		;;;int private6;
			
	_FUNCPTR 	.resource_alloc 		;;;XID (*resource_alloc)(	/* allocator function */ struct _XDisplay*  );
	_INT 		.byte_order		;;;int byte_order;		/* screen byte order, LSBFirst, MSBFirst */
	_INT 		.bitmap_unit		;;;int bitmap_unit;	/* padding and data requirements */
	_INT 		.bitmap_pad		;;;int bitmap_pad;		/* padding requirements on bitmaps */
	_INT 		.bitmap_bit_order	;;;int bitmap_bit_order;	/* LeastSignificant or MostSignificant */
	_INT 		.nformats		;;;int nformats;		/* number of pixmap formats in list */
			
	_POINTER 	.pixmap_format		;;;ScreenFormat *pixmap_format;	/* pixmap format list */
	_INT 		.private8		;;;int private8;
	_INT 		.release			;;;int release;		/* release of the server */
			
	_POINTER 	.private9,.private10	;;;struct _XPrivate *private9, *private10;
	_INT 		.qlen			;;;int qlen;		/* Length of input event queue */
			
	_ULONG 		.last_request_read	;;;unsigned long last_request_read; /* seq number of last event read */
	_ULONG 		.request			;;;unsigned long request;	/* sequence number of last request. */
	_POINTER 	.private11		;;;XPointer private11;
	_POINTER 	.private12		;;;XPointer private12;
	_POINTER 	.private13		;;;XPointer private13;
	_POINTER 	.private14		;;;XPointer private14;
	_UINT 		.max_request_size	;;;unsigned max_request_size; /* maximum number 32 bit words in request*/
			
	_POINTER 	.db			;;;struct _XrmHashBucketRec *db;
	_INT 		.private15		;;;int (*private15)(	struct _XDisplay*	);
			
	_POINTER 	.display_name		;;;char *display_name;	/* "host:display" string used on this connect*/
	_INT 		.default_screen		;;;int default_screen;	/* default screen for operations */
	_INT 		.nscreens		;;;int nscreens;		/* number of screens on this server*/
			
	_POINTER 	.screens			;;;Screen *screens;	/* pointer to list of screens */
	_ULONG 		.motion_buffer		;;;unsigned long motion_buffer;	/* size of motion buffer */
	_ULONG 		.private16		;;;unsigned long private16;
	_INT 		.min_keycode		;;;int min_keycode;	/* minimum defined keycode */
	_INT 		.max_keycode		;;;int max_keycode;	/* maximum defined keycode */
			
	_POINTER 	.private17		;;;XPointer private17;
	_POINTER 	.private18		;;;XPointer private18;
	_INT 		.private19		;;;int private19;
			
	_POINTER 	.xdefaults		;;;char *xdefaults;	/* contents of defaults from server */   
_endstruc
%define Display _XDisplay
%define Display_size _XDisplay_size

_struc Depth
	_INT		.depth			;;;int depth;		/* this depth (Z) of the depth */
	_INT		.nvisuals		;;;int nvisuals;		/* number of Visual types at this depth */
	_POINTER	.visuals		;;;Visual *visuals;	/* list of visuals possible at this depth */
_endstruc

_struc Visual
	_POINTER	.ext_data		;;;XExtData *ext_data;	/* hook for extension to hang data */
	VisualID 	.visualid		;;;VisualID visualid;	/* visual id of this visual */
	_INT		.class			;;;int class;		/* class of screen (monochrome, etc.) */
	_ULONG		.red_mask, .green_mask, .blue_mask ;;;unsigned long red_mask, green_mask, blue_mask;	/* mask values */
	_INT		.bits_per_rgb		;;;int bits_per_rgb;	/* log base 2 of distinct color values */
	_INT		.map_entries		;;;int map_entries;	/* color map entries */
_endstruc


_struc _XGC
    _POINTER 		.ext_data		;;;XExtData *ext_data;	/* hook for extension to hang data */
    GContext 		.gid			;;;GContext gid	/* protocol ID for graphics context */
    						;;;/* there is more to this structure, but it is private to Xlib */
_endstruc

_struc Screen
	_POINTER 	.ext_data		;;;XExtData *ext_data;	/* hook for extension to hang data */
	_POINTER	.display		;;;struct _XDisplay *display;/* back pointer to display structure */
	Window 		.root			;;;Window root;/* Root window id. */
	_INT 		.width, .height		;;;int width, height;/* width and height of screen */
	_INT 		.mwidth, .mheight	;;;int mwidth, mheight;/* width and height of  in millimeters */
	_INT 		.ndepths		;;;int ndepths;		/* number of depths possible */
	_POINTER	.depths			;;;Depth *depths;		/* list of allowable depths on the screen */
	_INT		.root_depth		;;;int root_depth;		/* bits per pixel */
	_POINTER	.root_visual		;;;Visual *root_visual;	/* root visual */
	_POINTER 	.default_gc		;;;GC default_gc;		/* GC for the root root visual */
	Colormap 	.cmap			;;;Colormap cmap;		/* default color map */
	_ULONG		.white_pixel		;;;unsigned long white_pixel;
	_ULONG		.black_pixel		;;;unsigned long black_pixel;	/* White and Black pixel values */
	_INT		.max_maps,min_maps	;;;int max_maps, min_maps;	/* max and min color maps */
	_INT		.backing_store		;;;int backing_store;	/* Never, WhenMapped, Always */
	_BOOL		.save_unders		;;;Bool save_unders;	
	_LONG		.root_input_mask	;;;long root_input_mask;	/* initial root input mask */
_endstruc

_struc XExposeEvent
	_INT .type				;;;int type;
	_ULONG .serial				;;;unsigned long serial;	/* # of last request processed by server */
	_BOOL .send_event			;;;Bool send_event;	/* true if this came from a SendEvent request */
	_POINTER .display			;;;Display *display;	/* Display the event was read from */
	Window .window				;;;Window window;
	_INT .x, .y				;;;int x, y;
	_INT .width, .height			;;;int width,height
	_INT .count				;;;int count;		/* if non-zero, at least this many more */
_endstruc


;#define ConnectionNumber(dpy) 	(((_XPrivDisplay)dpy)->fd)

%macro ConnectionNumber 1

	mov rax,[%1]
	mov eax,dword[rax+_XDisplay.fd]
%endmacro
;#define DefaultScreen(dpy) 	(((_XPrivDisplay)dpy)->default_screen)
%macro DefaultScreen 1
	mov rbx,[%1]
	mov eax,dword[rbx+_XDisplay.default_screen]
%endmacro

;#define ScreenOfDisplay(dpy, scr)(&((_XPrivDisplay)dpy)->screens[scr])
%macro ScreenOfDisplay 2
	mov rax,[%1]
	mov rax,qword[rax+_XDisplay.screens]
	mov rcx,rax
	xor rbx,rbx	
	mov ebx,dword[%2]
	mov eax,Screen_size
	mul rbx
	lea rax,[rcx + rax]
%endmacro

;#define RootWindow(dpy, scr) 	(ScreenOfDisplay(dpy,scr)->root)
%macro RootWindow 2
	ScreenOfDisplay %1,%2
	mov rax,qword[rax + Screen.root]
%endmacro

;#define BlackPixel(dpy, scr) 	(ScreenOfDisplay(dpy,scr)->black_pixel)
%macro BlackPixel 2
	ScreenOfDisplay %1,%2
	mov rax,qword[rax + Screen.black_pixel]
%endmacro

;#define WhitePixel(dpy, scr) 	(ScreenOfDisplay(dpy,scr)->white_pixel)
%macro WhitePixel 2
	ScreenOfDisplay %1,%2
	mov rax,qword[rax + Screen.white_pixel]
%endmacro
;#define DefaultColormap(dpy, scr)(ScreenOfDisplay(dpy,scr)->cmap)
%macro DefaultColormap 2
	ScreenOfDisplay %1,%2
	mov rax,qword[rax + Screen.cmap]
%endmacro


